#include <stdio.h>
#include <string.h>

#ifndef NO_STDLIB_H
#include <stdlib.h>
#else
char *getenv();
#endif

#include "util.c"

#define MAX_LENGTH 10000

char nextword[200];
int newline = 1;
char *input_string;
int input_length, input_index = 0;
int ENGLISH=0;


void initialize()
{
   printf("<HTML>\n");
   printf("<HEAD>\n<TITLE>Output of Bengali Writer</TITLE>\n</HEAD>\n");
   printf("<BODY BGCOLOR=#ffffff>\n");
   printf("<FONT SIZE=+2>\n");
}

void conclude()
{

   printf("</FONT>\n");
   printf("<P><HR SIZE=2 WIDTH=200 ALIGN=LEFT>\n");
   printf("<P><B>&#169; TBJS Software GmbH</B>\n");
   printf("<BR>Mail your comments and suggestions to ");
   printf("<A HREF=mailto:abhij@csa.iisc.ernet.in>abhij@csa.iisc.ernet.in</A>");
   printf("</BODY>\n");
   printf("</HTML>\n");
}

void flush_previous_word()
{
   int i;

   for (i=0; i<200; i++) nextword[i]=0;
}

void read_next_word()
{
   char ch;
   int i,done;

   do
   {
      sscanf(input_string,"%c",&ch);
      input_index++; input_string++;
   }
   while ((input_index < input_length)&&((ch==' ')||(ch=='\r')||(ch=='\f')||(ch=='\n')||(ch=='\t')));

   if (input_index < input_length)
   {
      i = 0; nextword[i] = ch; done=0;
      do
      {
         sscanf(input_string,"%c",&ch);
         input_index++; input_string++;
         done = ((ch==' ')||(ch=='\r')||(ch=='\f')||(ch=='\n')||(ch=='\t'));
         i++; if (!done) nextword[i] = ch;
      } while (!((input_index >= input_length)||(done)));
   }
}

int vowel(c)
char c;
{
   return((c=='a')||(c=='e')||(c=='i')||(c=='o')||(c=='u')||(c=='R')||(c=='L'));
}

int punctuation(c)
char c;
{
   return((c=='H')||(c=='|')||(c=='!')||(c==':')||(c==',')||(c=='-')||
           (c=='(')||(c==')')||(c=='.')||(c=='?')||(c=='"')||(c=='/')||
                                         (c=='\\')||(c=='_')||(c=='~'));
}

void put_punc_symb(c)
char c;
{
   switch(c)
   {
      case 'H':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/banjon/H.gif>");break;}
      case '|':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/misc/hasanta.gif>");break;}
      case '!':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/bang.gif>");break;}
      case ':':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/colon.gif>");break;}
      case ',':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/comma.gif>");break;}
      case '-':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/hyphen.gif>");break;}
      case '(':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/leftparen.gif>");break;}
      case ')':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/rightparen.gif>");break;}
      case '.':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/period.gif>");break;}
      case '?':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/question.gif>");break;}
      case '"':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/quote.gif>");break;}
      case '/':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/punc/slash.gif>");break;}
      case '~':{printf("<IMG SRC=http://144.16.67.96/~barda/bengali/misc/space.gif>");break;}
      case '\\':{printf("<BR>");break;}
   }
}

int number(char c)
{
   return((c >= '0') && (c <= '9'));
}

int exists_file(char directory[], char fname[])
{
   char command[100];

   sprintf(command,"test -e /u1/barda/bengali/%s/%s.gif",directory,fname);
   return(!(system(command)));
}

void error_message(char sequence[])
{
   printf("<IMG SRC=http://144.16.67.96/~barda/bengali/misc/error.gif>");
}


void process_next_word(word)
char word[];
{
   char ban[40],swar[40],part[80];
   int length = strlen(word);
   int index = 0, i;

   for (i=0; i<40; i++)
   {
      ban[i] = 0; swar[i]= 0;
   }
   for (i=0; i<80; i++)
      part[i]= 0;


   if (ENGLISH)
   {
      if ((strcmp(word,"</ENG>") != 0))
         printf("%s",word);
      else
         ENGLISH = 0;
   }
   else
   {
   if (punctuation(word[index]))
   {
      put_punc_symb(word[index]); index++;
      if ((word[index-1]=='\\')&&(index==length)) newline=1;
   }
   else
   if (number(word[index]))
   {
      printf("<IMG SRC=http://144.16.67.96/~barda/bengali/sankhya/%c.gif>",word[index]);
      index++;
   }
   else
   if (vowel(word[index]))
   {
      int i=0;

      do
      {
         swar[i] = word[index]; i++; index++;
      } while (vowel(word[index]));
      if (exists_file("swar",swar))
         printf("<IMG SRC=http://144.16.67.96/~barda/bengali/swar/%s.gif>",swar);
      else
         error_message(swar);
   }
   else if (word[index] != 0)
   {
      int i = 0, status = 0;

      if (word[index] == '<')
      {
         index++;
         while ((word[index] != '>') && (word[index] != 0) && (!(punctuation(word[index]))))
         {
            part[i] = word[index]; i++; index++;
         }
         if (word[index] == '>') index++;
         if ((strcmp(part,"ENG")) == 0)
         {
            ENGLISH = 1; status = 3;
         }
         else
         if (vowel(part[0]))
         {
            if (exists_file("swar",part))
               printf("<IMG SRC=http://144.16.67.96/~barda/bengali/swar/%s.gif>",part);
            else
               error_message(swar);
         }
         else
            status = 2;
      }
      else
      {
         status = 1;
         while ((word[index] != 0) && (word[index] != '<') && 
                 (!vowel(word[index])) && (!(punctuation(word[index])))
                                            && (!(number(word[index]))))
         {
            ban[i] = word[index]; i++; index++;
         }
      }
      if ((status == 1) || (status == 2))
      {
        i = 0;
        while (vowel(word[index]))
        {
           swar[i] = word[index];
           i++; index++;
        }
        if (!(exists_file("swar",swar)) && strcmp(swar,""))
           error_message(swar);
        else
        {
         if (strcmp(swar,"i") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/i.gif>");
         if (strcmp(swar,"e") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/e.gif>");
         if (strcmp(swar,"oi") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/oi.gif>");
         if (strcmp(swar,"o") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/e.gif>");
         if (strcmp(swar,"ou") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/e.gif>");

         if (status == 1) 
         {
            int len = strlen(ban), chandrabindu = 0;

            if (ban[len -1] == '^')
            {
               chandrabindu = 1; ban[len - 1] = 0; len--;
            }
            if (len > 0) 
            {
               if (exists_file("banjon",ban))
                  printf("<IMG SRC=http://144.16.67.96/~barda/bengali/banjon/%s.gif>",ban);
               else
                  error_message(ban);
            }

            if (chandrabindu) 
                printf("<IMG SRC=http://144.16.67.96/~barda/bengali/banjon/^.gif>");
         }

         if (status == 2)
         {
            int ref = 0, jafala = 0, chandrabindu = 0,  len = strlen(part);

            if (part[len - 1] == '^')
            {
               chandrabindu = 1; part[len - 1] = 0; len--;
            }
            if (part[0] == 'r')
            {
               ref = 1;
               for (i = 0; i < len; i++) part[i] = part[i+1];
               len--;
            }
            if (part[len - 1] == 'y')
            {
               jafala = 1; part[len - 1] = 0; len--;
            }

            if (!((ref) || (jafala))) 
            {
               if (exists_file("jukto",part))
                  printf("<IMG SRC=http://144.16.67.96/~barda/bengali/jukto/%s.gif>",part);
               else
                  error_message(part);
               }
               else
               {
                  if (exists_file("jukto",part))
                     printf("<IMG SRC=http://144.16.67.96/~barda/bengali/jukto/%s.gif>",part);
                  else if (exists_file("banjon",part))
                     printf("<IMG SRC=http://144.16.67.96/~barda/bengali/banjon/%s.gif>",part);
                  else
                     error_message(part);

               if (ref) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/jukto/ref.gif>");
               if (jafala) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/jukto/jafala.gif>");
            }
            if (chandrabindu) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/banjon/^.gif>");
         }
         if (strcmp(swar,"aa") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/aa.gif>");
         if (strcmp(swar,"ee") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/ee.gif>");
         if (strcmp(swar,"u") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/u.gif>");
         if (strcmp(swar,"oo") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/oo.gif>");
         if (strcmp(swar,"R") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/R.gif>");
         if (strcmp(swar,"Ri") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/R.gif>");
         if (strcmp(swar,"o") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/aa.gif>");
         if (strcmp(swar,"ou") == 0) printf("<IMG SRC=http://144.16.67.96/~barda/bengali/kar/ou.gif>");
        }
      }
   }

   if (index < length)
   {
      for (i = index; i <= length; i++) word[i - index] = word[i];
      process_next_word(word);
   }
   }
}
   
      

main()
{
   int cl, x;
   char *input_name;

   printf("Content-type: text/html%c%c",10,10);

   if(strcmp(getenv("REQUEST_METHOD"),"POST")) {
      printf("This script should be referenced with a METHOD of POST.\n");
       printf("If you don't understand this, see this ");
       printf("<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c",10);
       exit(1);
   }
   if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) {
       printf("This script can only be used to decode form results. \n");
       exit(1);
   }
   cl = atoi(getenv("CONTENT_LENGTH"));

   initialize();

   input_string = fmakeword(stdin,'&',&cl);
   plustospace(input_string);
   unescape_url(input_string);
   input_name = makeword(input_string,'=');
   input_length = strlen(input_string);

   printf("<H1>The Output from<BR>Bengali Writer (Version 1.4)</H1>");

   while (input_index < input_length)
   {
      flush_previous_word();
      read_next_word();
      if (ENGLISH) printf(" ");
      else
      {
          if (!(newline))
             printf("\n<IMG SRC=http://144.16.67.96/~barda/bengali/misc/space.gif>\n");
          else
             printf("\n");
          newline = 0;
      }
      if ((strcmp(nextword,"")) != 0)
         process_next_word(nextword);
   }
   conclude();
}

